
          page ,132

title     PDD.COM - Printed Diskette Directory

comment   * Revision to COVER.COM to:
               set printer before keyboard input
               accept drive plus path or drive only
               not print if drive or path not specified     
               not print if diskette has no files
               apply to diskettes with single files
               apply only to DOS 2.x or greater
               include subdirectory names in listing
               allow longer title and show maximum length on screen
               print two directories on page with no separation
               allow up to 276 filenames in double listing
               handle free disk space > 1,000,000 bytes for HD disks
          *

          if1

rkbd      macro     count,buff                    ;read str from kbd
          mov  ah,3fh
          mov  bx,0
          mov  cx,count
          mov  dx,offset buff
          int  21h
          endm

w2p       macro     count,data                    ;write str to prn
          mov  ah,40h
          mov  bx,4
          mov  cx,count
          mov  dx,offset data
          int  21h
          endm

w2s       macro     count,data                    ;write str to scrn
          mov  ah,40h
          mov  bx,1
          mov  cx,count
          mov  dx,offset data
          int  21h
          endm

wx2p      macro     count,data                    ;write ch to prn x times
          local     again
          mov  bx,4
          mov  cx,count
          mov  dx,offset data
again:
          push cx
          mov  cx,1
          mov  ah,40h
          int  21h
          pop  cx
          loop again
          endm
          endif

cseg      segment
          assume    cs:cseg,ds:cseg,es:cseg,ss:cseg
          org       100h

start:
          jmp  main
;------------------------------------------------------------------------------------------
;DATA AREA

dos_vers_msg        db   0ah,0dh,'Not DOS version 2.0 or greater.  Exiting program.'
dos_vers_msg_len    equ	 $ - dos_vers_msg

tgt_path_msg        db   0dh,0ah,34 dup (0),32 dup (5fh),0dh
                    db   'Enter path to list (ENTER to quit): '
tgt_path_msg_len    equ	 $ - tgt_path_msg

tgt_path            db   40 dup (0)               ;40h = 64d
wc_name1            db   '\*.*',0
wc_name2            db   ':\*.*',0
path_len            db   0

not_path_msg        db   0dh,0ah,'Invalid drive'
not_path_msg_len    equ	 $ - not_path_msg

title_msg           db   13 dup (0),53 dup (5fh),0dh
                    db   'Enter Title: '
title_msg_len       equ	 $ - title_msg

disk_title          db   36h                      ;36h = 54d
                    db   0
                    db   54 dup (?)

disk_heading        db   55 dup (20h)
                    db   'Free:',20h
free_space          db   9 dup (20h)
current_mon         db   2 dup (20h),2fh
current_day         db   2 dup (20h),2fh
current_year        db   2 dup (20h)
disk_heading_len    equ	 $ - disk_heading

free_hex            db   4 dup (0)
big_num             db   40h,42h,0fh,0            ;0f 42 40h = 1,000,000

file_size           db   6 dup (0)
dta                 db   44 dup (0)

files_over_msg      db   0dh,0ah,'More than 276 files in this path.  Exiting program.'
files_over_msg_len  equ	 $ - files_over_msg

zero_str            db   5 dup (20h),30h
sub_dir             db   ' <DIR>'

set_prn             db   0fh,1bh,30h,1bh,43h,58h  ;condensed, 8 lpi, 88 lpp
                    db   6 dup (0)
init_prn            db   1bh,40h                  ;initialize prn
                    db   6 dup(0)

default_drive       db   ?
num_drives          db   ?
size_flag           db   0
file_count          dw   ?
file_count2         dw   0
lines_to_prt        db   ?
ff_flag             db   0

ff                  db   0ch
space               db   20h
dash                db   2dh
crlf                db   0dh,0ah

left                db   7ch,4 dup (20h)
right               db   4 dup (20h),7ch,0dh,0ah
;------------------------------------------------------------------------------------------
main:

; get dos version number

          mov  ah,30h                             ;get DOS version number
          int  21h
          or   al,al                              ;if al = 0, vers 1
          jnz  set_printer

; wrong version

          w2s  dos_vers_msg_len,dos_vers_msg
          jmp  exit

; set printer 

set_printer:
          w2p  12,set_prn                         ;condensed, 8 lpi, 44 lpp

; get default drive

          mov  ah,19h                             ;get default drive
          int  21h
          mov  default_drive,al                   ;in al, 0 = A, 1 = B, etc
          mov  dl,al
          mov  ah,0eh                             ;select disk
          int  21h
          mov  num_drives,al
          

; get target path 

tgt_drv:
          w2s  tgt_path_msg_len,tgt_path_msg
          rkbd 28h,tgt_path

          mov  al,byte ptr tgt_path
          cmp  al,0dh                             ;check if cr (0dh)
          jz   no_path                            ;if so, quit
          or   al,20h                             ;else convert to lower case
          sub  al,60h                             ;convert to hex
          cmp  al,num_drives                      ;1=A, 2=B, etc
          ja   invalid_drv                        ;to display invalid msg
          dec  al
          mov  dl,al                              ;0=A, 1=B, etc
          mov  ah,0eh                             ;selects input drive
          int  21h

          xor  cl,cl
          mov  di,offset tgt_path
          mov  al,0dh                             ;0dh = cr

path_ch:
          inc  cl
          scasb                                   ;chk for cr
          jne  path_ch
          dec  di                                 ;if found
          dec  cl
          cmp  cl,0                               ;chk for no entry
          jz   no_path                            ;if no path entered
          cmp  cl,1                               ;chk for drive w/o colon
          jz   colon_wc                           ;if drive only
          mov  cx,5
          mov  si,offset wc_name1                 ;wild card name w/o colon
          jmp  short count

no_path:
          jmp  short quit                         ;if no path input

colon_wc:
          mov  cx,6
          mov  si,offset wc_name2                 ;wild card name w/ colon

count:
          rep  movsb                              ;read in wild card name
          mov  cx,0                               ;set count to zero
          mov  si,offset tgt_path                 ;to count path len

next_ch:
          lodsb
          or   al,al                              ;end of path name?
          je   end_path
          inc  cx                                 ;if not, try next ch
          jmp  next_ch

end_path:
          xor  ch,ch
          mov  path_len,cl                        ;save path len
          jmp  short dir_info

invalid_drv:
          w2s  not_path_msg_len,not_path_msg
          jmp  tgt_drv                            ;try again

; get input from disk

dir_info:
          call get_heading
          call dir_entries
          or   cx,cx
          jz   quit                               ;if disk has no files
          cmp  cx,114h                            ;114h = 276d
          ja   too_many_files                     ;if more than 276 files
          cmp  cx,1
          jz   skip_sort                          ;if only one file
          call bubble_sort

skip_sort:
          call prt_dir
          jmp  tgt_drv                            ;return for another directory

too_many_files:
          w2s  files_over_msg_len,files_over_msg

; termination - formfeed, initialize printer, return to orig drive

quit:

; formfeed

          cmp  ff_flag,0                          ;check if top half of page
          jz   initialize_printer                 ;if not, jump
          w2p  1,ff

; initialize printer

initialize_printer:
          w2p  8,init_prn

; return to original drive

          mov  dl,default_drive
          mov  ah,0eh                             ;selects default drive
          int  21h

; exit to dos

exit:
          w2s  2,crlf                             ;send crlf to scrn
          
          mov  ax,4c00h                           ;terminate and return to DOS
          int  21h

;------------------------------------------------------------------------------------------
; procedure    get_heading
; purpose      to get heading for printed directory
; input        from kbd
; output       str w/title, free space on disk nd current date

get_heading    proc

; fill disk heading buffer with spaces

          mov  di,offset disk_heading
          mov  cx,37h                             ;37h = 55d
          mov  al,20h                             ;20h = space
          rep  stosb                              ;reset buff

; get keyboard input of disk directory title
; Note:   Function 3fh could be used here but it is less convenient than function 0ah when
;         using CED or PCED.  Determining the length of the title is also less convenient.

          w2s  title_msg_len,title_msg

          mov  ah,0ah                             ;get buffered input from kbd
          mov  dx,offset disk_title
          int  21h

          mov  al,disk_title+1                    ;len of title
          cbw
          mov  cx,ax
          mov  si,offset disk_title+2             ;title
          mov  di,offset disk_heading             ;store in disk_heading
          rep  movsb

; get amount of free space on target disk

          xor  dl,dl
          mov  ah,36h                             ;get free disk space
          int  21h
                                                  ;AX = sectors/cluster
                                                  ;BX = # of available clusters
                                                  ;CX = bytes/sector
                                                  ;DX = clusters/drive
          mul  bx                                 ;AX is now sectors available
          mul  cx                                 ;bytes available now in DX,AX
          mov  size_flag,0                        ;clear size_flag

          mov  di,offset free_hex                 ;buff to load free space, lsb first
          mov  [di],ax                            ;to use al for loading di
          mov  [di+2],dx
          mov  cx,4                               ;to compare free space vs 1,000,000d
          std                                     ;to begin at msb
          mov  si,offset big_num+3
          mov  di,offset free_hex+3
          repe cmpsb
          cld
          
          ja   small_size                         ;if free space is < 1,000,000d
          mov  bx,400h                            ;if not,
          div  bx                                 ;convert free space to Kb
          xor  dx,dx                              ;zero out remainder
          mov  size_flag,1                        ;set size_flag

small_size:
          mov  di,offset free_space
          call hex2dec
          mov  di,offset free_space+6             ;to clear 7th byte
          mov  al,20h
          stosb
          cmp  size_flag,1                        ;is free space >= 1,000,000d ?
          jne  sys_date                           ;if not, jmp
          mov  di,offset free_space+6             ;else store 'K' in 7th byte
          mov  al,4bh                             ;4bh = 'K'
          stosb
          
; get system date

sys_date:
          mov  ah,2ah                             ;get system date
          int  21h
          sub  cx,76ch                            ;CX = year (1980 - 2099), 76ch = 1900d
          mov  di,offset current_year
          mov  al,cl
          call hex2asc                            ;convert to ascii
          mov  di,offset current_mon
          mov  al,dh                              ;DH = month (1 - 12)
          call hex2asc
          mov  di,offset current_day
          mov  al,dl                              ;DL = day (1 - 31)
          call hex2asc
          ret

get_heading    endp

;------------------------------------------------------------------------------------------
; procedure    hex2dec
; purpose      convert hex numbers to decimal
; input        hex number in dx,ax, dest in di
; output       ascii decimal numbers in di

hex2dec   proc

; divide by 10,000 and convert quotient to ascii

          push di
          div  ten4                               ;divide by 10,000
                                                  ; quotient in AX, remainder in DX
          aam                                     ;convert to BCD
                                                  ; AH = AL/0ah, AL = remainder
          or   ax,3030h                           ;convert bytes in AH and AL to ascii
          xchg ah,al                              ;put lsb first
          stosw

; divide by 1,000, 100 and 10 and convert quotients to ascii

          mov  cx,3
          mov  si,offset ten3
hex2dec1:
          mov  ax,dx 
          xor  dx,dx
          div  word ptr [si]                      ;word ptr [si] = 1,000, then 100, then 10
          or   al,30h                             ;convert to ascii
          stosb
          add  si,2
          loop hex2dec1
          
; convert last remainder to ascii

          or dl,30h                               ;convert last remainder to ascii
          mov  al,dl
          stosb

; replace leading zeros with spaces

          mov  cx,5                               ;set count to 5
          pop  di                                 ;back to beginning of str
          mov  al,20h

hex2dec2:
          cmp  byte ptr [di],30h                  ;check for leading zeros (30h = 0 ascii)
          jnz  hex2dec3                           ;if not, jump
          stosb                                   ;else prt space
          loop hex2dec2

hex2dec3:
          ret

ten4           dw   2710h                         ;2710h = 10,000d
ten3           dw   3e8h                          ; 3e8h = 1,000d
               dw   64h                           ;  64h = 100d
               dw   0ah                           ;  0ah = 10d

hex2dec   endp

;------------------------------------------------------------------------------------------
; procedure    hex2asc
; purpose      convert a hex number to ascii
; input        ax, dest in di
; output       two ascii numbers in di

hex2asc   proc

          aam                                     ;convert to BCD
                                                  ; AH = AL/0ah, AL = remainder
          or   ax,3030h                           ;convert AH and AL bytes to ascii
          xchg al,ah                              ;to put lsb first
          stosw                                   ;store 2 bytes at DI
          ret

hex2asc   endp

;------------------------------------------------------------------------------------------
; procedure    dir_entries
; purpose      put entries from target disk into dta
; input        tgt_path ending in *.*
; output       entry  in dta

dir_entries    proc

; set offset buffer, 276 words of zero (69 lines at 4 filenames per line for double page)

          mov  di,offset last_byte
          xor  ax,ax
          mov  cx,114h                            ;114h = 276d
          rep  stosw

; prepare to list files

          mov  bx,offset last_byte
          mov  di,offset last_byte+228h           ;after buffer created above

; set dta address

          mov  ah,1ah                             ;set dta address
          mov  dx,offset dta
          int  21h

; search for first entry

          mov  ah,4eh                             ;find first match
          mov  cx,10h                             ;attr for subdirs
          mov  dx,offset tgt_path
          int  21h
          mov  cx,0                               ;to set count of filenames

chk_match:
          jc   no_match
          call to_buff
          inc  cx

; search for next entry

          mov  ah,4fh                             ;find next match
          int  21h
          jmp  chk_match

no_match:
          mov  file_count,cx
          ret

dir_entries    endp

;------------------------------------------------------------------------------------------
; procedure    to_buff
; purpose      store filenames with sizes and offsets in buffer
; input        dta info
; output       data stored in buffer, last_byte

to_buff   proc

          push cx

; read in filename
          xor  cx,cx
          mov  si,offset dta+30                   ;offset of filename in dta
          mov  al,[si]
          cmp  al,2eh                             ;2eh = period
          jz   not_entry                          ;if period entry, skip

get_len:
          inc  cx
          lodsb
          or   al,al
          je   sto_fname
          jmp  get_len

sto_fname:
          mov  si,offset dta+30                   ;reset si
          mov  [bx],di                            ;bx contains offset to filenames
          add  bx,2
          rep  movsb                              ;read in filename
          jmp  short get_size

not_entry:
          pop  cx
          dec  cx
          jmp  short not_file


; read in file size

get_size:
          mov  si,offset dta+26                   ;offset of file size in dta
          mov  cx,4
          rep  movsb                              ;read in filesize

          pop  cx

not_file:
          ret

to_buff   endp

;------------------------------------------------------------------------------------------
; procedure    bubble_sort
; purpose      to bubble sort filenames by ordering offsets
; input        buffer addresses of files
; output       reordered buffer addresses of files

bubble_sort    proc

          dec  cx
          mov  si,offset last_byte                ;SI contains offsets to filenames

set_buffs:
          mov  di,si
          add  di,2
          mov  dx,cx

chk_order:
          call cmp_names                          ;to check order
          jbe  no_swap
          mov  ax,[si]                            ;swap routine for offsets
          xchg ax,[di]
          mov  [si],ax

no_swap:
          add  di,2
          dec  dx                                 ;one less to sort
          jnz  chk_order
          add  si,2
          loop set_buffs
          ret

bubble_sort    endp

;------------------------------------------------------------------------------------------
; procedure    cmp_names
; purposes     determine if filenames are alphabetic order
; input        adjacent filenames in buffer last_byte
; output       cmp flags set

cmp_names proc
          
          push si
          push di
          push cx
          mov  cx,0ch                             ;12 includes ext
          mov  si,[si]
          mov  di,[di]
          repz cmpsb
          pop  cx
          pop  di
          pop  si
          ret

cmp_names endp          

;------------------------------------------------------------------------------------------
; procedure    prt_dir
; purpose      print disk directory
; input        disk heading, files buffer, file_count, etc
; output       directory to printer

prt_dir   proc

          xor  ff_flag,1                          ;flag for top or bottom dir on page

; set number of lines with filenames and lines to print, excluding header and lower line

          mov  lines_to_prt,21h                   ;21h = 33d
          mov  ax,file_count
          cmp  ax,84h                             ;84h = 132d
          jbe  count_lines                        ;if less than or equal 132 files
          cmp  ff_flag,1                          ;to start new page if more than 132 files
                                                  ; and not at top of page already
          jz   skp_ff
          push ax                                 ;save file count
          w2p  1,ff                               ;send formfeed
          xor  ff_flag,1                          ;set formfeed flag
          pop  ax                                 ;restore file count
          
skp_ff:
          sub  ax,84h                             ;get count of files on second page
          mov  file_count2,ax                     ;save in file_count2
          mov  ax,84h                             ;set file count to 132

count_lines:
          mov  dh,4
          div  dh                                 ;AX = # of lines at 4 files/line
          or   ah,ah
          jz   lines_ok                           ;if remainder = 0
          inc  al                                 ;else one more line
          cbw

lines_ok:
          push ax                                 ;# of lines w/ filenames
          cmp  ff_flag,0
          jz   skp_top

; print top and heading

          wx2p 58h,dash
          w2p  2,crlf

skp_top:
          call blank_line
          call lt_side
          w2p  disk_heading_len,disk_heading
          call rt_side
          call blank_line

; get buffer offsets

          pop  cx                                 ;# of lines w/ filenames
          mov  bp,cx
          shl  bp,1                               ;x 2 - each offset is 2 bytes - bp now
                                                  ; contains 2 x # of lines w/ filenames
                                                  ; used to set order files are printed
                                                  ; on line
          mov  si,offset last_byte                ;si contains offsets to filenames


; print one line of filenames at 4 per line

get_line:
          call lt_side
          mov  dl,4                               ;for 4 filenames per line
          xor  bx,bx

get_file:
          call file_info                          ;print one filename and size, and print
                                                  ; 2 spaces unless file is 4th on line
          add  bx,bp                              ;to get new offset in SI
          dec  dl                                 ;dec # of files per line
          jnz  get_file                           ;if line not complete
          call rt_side
          add  si,2                               ;get offset for next file in alphabetic
                                                  ; order
          dec  lines_to_prt
          loop get_line
          mov  cl,lines_to_prt
          xor  ch,ch
          jcxz prt_last                           ;if box filled with printed lines

; print remaining lines in box as blank

prt_blank:
          call blank_line
          loop prt_blank

prt_last:
          wx2p 58h,dash                           ;prt bottom line of box
          w2p  2,crlf
          cmp  file_count2,0                      ;chk if more than 132 files
          jbe  do_ff                              ;if not, chk for formfeed
          mov  ax,file_count2                     ;else, move count of rest of files to ax
          mov  file_count2,0                      ;reset file_count2
          xor  ff_flag,1                          ;set formfeed flag
          mov  lines_to_prt,24h                   ;set lines to prt whole box
          mov  dh,4
          div  dh                                 ;divide file count by 4 
                                                  ; to get lines to prt
          or   ah,ah                              ;chk remainder
          jz   lines_ok2
          inc  al
          cbw

lines_ok2:
          mov  cx,ax                              ;move file count to cx
          mov  bp,cx                              ; and to bp
          shl  bp,1                               ;x 2
          mov  si,offset last_byte+108h           ;after offset of 132 files
          jmp  get_line

do_ff:
          cmp  ff_flag,1                          ;chk re formfeed
          jz   no_ff
          w2p  1,ff

no_ff:
          ret

prt_dir   endp

;------------------------------------------------------------------------------------------
; procedure    blank_line
; purpose      print blank line inside box
; input        none
; output       blank line with left and right sides to printer

blank_line     proc

          push cx
          call lt_side
          wx2p 4eh,space
          call rt_side
          pop  cx
          ret

blank_line     endp

;------------------------------------------------------------------------------------------
; procedure    lt_side
; purpose      print left side of box
; input        none
; output       send left side of box to printer

lt_side   proc

          push cx
          push dx
          w2p  5,left
          pop  dx
          pop  cx
          ret

lt_side   endp

;------------------------------------------------------------------------------------------
; procedure    rt_side
; purpose      print right side of box
; input        none
; output       send right side of box to printer

rt_side   proc          

          push cx
          push dx
          w2p  7,right
          pop  dx
          pop  cx
          ret

rt_side   endp

;------------------------------------------------------------------------------------------
; procedure    file_info
; purpose      to send filenames to printer in correct order
; input        offset of filename in last_byte buffer
; output       send filename to printer

file_info      proc

; print filename

          push bx
          push cx
          push dx
          mov  cx,0ch                             ;for filename + ext
          mov  di,[bx+si]                         ;offset of file to be printed
          or   di,di                              ;check if ch = 0
          mov  bx,4                               ;to printer
          jz   prt_18_sp                          ;if so, blank filename and size

chk_0:
          mov  dl,[di]
          or   dl,dl                              ;check if ch = 0
          jz   prt_x_sp                           ;if so, make it space
          mov  ah,40h                             ;write handle
          push cx
          mov  cx,1
          mov  dx,di          
          int  21h                                ;else prt ch
          pop  cx
          inc  di
          loop chk_0                              ;thru 12 chs
          jmp  short prt_size
 
prt_x_sp:                                         ;to print balance of filename as spaces
          mov  ah,40h
          push cx
          mov  cx,1
          mov  dx,offset space
          int  21h
          pop  cx
          loop prt_x_sp
          jmp  short prt_size

prt_18_sp:                                        ;print 18 spaces for filename and size
          wx2p 12h,space
          jmp  short chk_4_files

; print file size

prt_size:
          inc  di
          mov  ax,[di]                            ;get file size, lsb
          mov  dx,[di+2]                          ;get file size, msb
          push si
          mov  di,offset file_size
          call hex2dec                            ;convert hex file size to decimal

          mov  cx,6
          mov  si,offset file_size
          mov  di,offset zero_str
          repe cmpsb                              ;check if file size is zero, i.e. subdir
          pop  si
          jz   file2dir                           ;if so, print '<DIR>'
          mov  dx,offset file_size                ;else print size
          jmp  short print_size
          
file2dir:
          mov  dx,offset sub_dir

print_size:
          mov  ah,40h
          mov  cx,6
          int  21h

; print 2 spaces between files

chk_4_files:
          pop  dx
          push dx
          dec  dl
          jz   file_4                             ;if 4 files already on line
          wx2p 2,space          

file_4:          
          pop  dx
          pop  cx
          pop  bx
          ret

file_info      endp


last_byte:

cseg      ends 
          
          end  start
